﻿/**
 * Created by wangkang on 2017/3/1.
 */
var http = require('http')
var crypto = require('crypto');
function md5 (text) {
    return crypto.createHash('md5').update(text).digest('hex').toUpperCase();
};
function base64 (text) {
    var b = new Buffer(text);
    return b.toString('base64');
};
Date.prototype.Format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}
var account = "N000*****606"   //  替换为您的账户
var secret = "123456"           // 替换为您的api密码
var time = new Date().Format('yyyyMMddhhmmss')
var auth = base64(account + ':' + time)
var sig = md5(account + secret + time)
var headers = {'Accept': 'application/json', 'Content-Type': 'application/json;charset=utf-8','Authorization':auth}
var postdata = JSON.stringify({exten:'8000'})   // 调用查询坐席状态接口需要发送的数据，根据具体接口做相应修改
var options = {
    host: 'apis.7moor.com',
    method: 'POST',
    path: '/v20160818/user/queryUserState/' + account + '?sig=' + sig, // 查询坐席状态接口路径，根据具体接口做相应修改
    headers: headers
}
var req = http.request(options, function (res) {
    var chunks = [], length = 0;
    res.on('data',function (chunk) {
        length += chunk.length;
        chunks.push(chunk);
    }).on('end', function () {
        var data = new Buffer(length), pos = 0, l = chunks.length;
        for(var i=0;i<l;i++){
            chunks[i].copy(data, pos);
            pos += chunks[i].length;
        }
        console.log('the response is ..' + data)
    }).on('error',function(err){
        console.log('err occured : ' + err.stack)
    });
}).on('error',function(err){
    console.log('err occured : ' + err.stack)
});
req.write(postdata);
req.end();